Perp deploy
curl --request POST \
--url https://api.hyperliquid.xyz/exchange \
--header 'Content-Type: application/json' \
--data '
{
"action": {
"type": "perpDeploy",
"setOracle": {
"dex": "xyz",
"oraclePxs": [
[
"BTC",
"50000.0"
]
],
"markPxs": [
[
[
"BTC",
"50000.0"
]
]
],
"externalPerpPxs": []
}
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": null
}
'import requests
url = "https://api.hyperliquid.xyz/exchange"
payload = {
"action": {
"type": "perpDeploy",
"setOracle": {
"dex": "xyz",
"oraclePxs": [["BTC", "50000.0"]],
"markPxs": [[["BTC", "50000.0"]]],
"externalPerpPxs": []
}
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'perpDeploy',
setOracle: {
dex: 'xyz',
oraclePxs: [['BTC', '50000.0']],
markPxs: [[['BTC', '50000.0']]],
externalPerpPxs: []
}
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};
fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": "<string>",
"response": {}
}Hyperliquid node API
perpDeploy | Hyperliquid exchange
Deploys a new perpetual contract on a Hyperliquid perp DEX. Chainstack supports perpDeploy on Hyperliquid exchange JSON-RPC nodes.
POST
/
exchange
Perp deploy
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.
Parameters
Required parameters
action(object, required) — The action object containing:type(string) — Must be"perpDeploy"config(object) — Perpetual deployment configuration
nonce(number, required) — Current timestamp in milliseconds (must be recent)signature(object, required) — EIP-712 signature of the action
Optional parameters
vaultAddress(string, optional) — Address when trading on behalf of a vault or subaccount
Returns
Returns an object with the action status:status—"ok"if request processedresponse— Contains action result data
Example request
curl -X POST https://api.hyperliquid.xyz/exchange \
-H "Content-Type: application/json" \
-d '{
"action": {"type": "perpDeploy"},
"nonce": 1234567890123,
"signature": {...}
}'
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
from eth_account import Account
# Signing is required: load the deployer wallet from its private key.
wallet = Account.from_key("0x...")
exchange = Exchange(wallet, constants.MAINNET_API_URL)
# perpDeploy / registerAsset: register a new perp asset on a builder-deployed perp DEX.
result = exchange.perp_deploy_register_asset(
dex="test",
max_gas=1000000,
coin="USDC",
sz_decimals=8,
oracle_px="1",
margin_table_id=1,
only_isolated=False,
schema=None,
)
print(result)
import * as hl from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";
// Signing is required: load the deployer wallet from its private key.
const wallet = privateKeyToAccount("0x..."); // viem or ethers
const transport = new hl.HttpTransport(); // public mainnet API
const client = new hl.ExchangeClient({ transport, wallet });
// perpDeploy / registerAsset: register a new perp asset on a builder-deployed perp DEX.
const result = await client.perpDeploy({
registerAsset: {
maxGas: 1000000,
assetRequest: {
coin: "USDC",
szDecimals: 8,
oraclePx: "1",
marginTableId: 1,
onlyIsolated: false,
},
dex: "test",
schema: null,
},
});
console.log(result);
Use case
- Perp deploy — Deploys a new perpetual contract on a Hyperliquid perp DEX.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.
Body
application/json
Last modified on June 24, 2026
Was this page helpful?
⌘I